SUBROUTINE cropcontrols(CROP1,i_subas,lu_counter,tc_counter,act_day,onset,tcid_instance2,id_tc_type2)

use climo_h
use common_h
use hymo_h
use params_h
use time_h
use lake_h
use routing_h
use reservoir_h
use erosion_h

IMPLICIT NONE


REAL,INTENT(INOUT) :: CROP1(30,subasin,maxsoter,maxterrain,maxsoil) 
INTEGER,INTENT(IN) :: i_subas,lu_counter,tc_counter,id_tc_type2
INTEGER :: act_day,onset,tcid_instance2,i_svc,i_lu


				!conrad: debug
				if (isnan(CROP1(7,i_subas,lu_counter,tc_counter,1))) then
					write(*,*)'FATAL ERROR!!! in cropcontrol'
				end if
!period(2,i_subbas,y_act)=onset

IF (act_day==onset) THEN
!monsoon onset day! start seeding!
	DO i_svc=1,nbr_svc(tcid_instance2)
		CROP1(7,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset development
		CROP1(8,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset height
		CROP1(9,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset LAI
		CROP1(10,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset roots
		CROP1(12,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset cycle
		CROP1(14,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset stage
		CROP1(11,i_subas,lu_counter,tc_counter,i_svc)=alb(CROP1(3,i_subas,lu_counter,tc_counter,i_svc),1)	!reset albedo
		CROP1(5,i_subas,lu_counter,tc_counter,i_svc)=croppatv(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))*croppats(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))	!reset crop to initial
	END DO
END IF

!check for harvested crops, refresh parameters LAI, height, roots, albedo with own values
DO i_svc=1,nbr_svc(tcid_instance2)
	IF (CROP1(14,i_subas,lu_counter,tc_counter,i_svc)==9.) THEN
		
		!store harvest: 1:crop 2:amount kg/ha
		!IF (i_subas==6.AND.lu_counter==2.AND.tc_counter==1) write(*,*)'stoppop'
		if (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)==1.) then
		CROP1(22,i_subas,lu_counter,tc_counter,i_svc)=CROP1(5,i_subas,lu_counter,tc_counter,i_svc)*100000.+ CROP1(13,i_subas,lu_counter,tc_counter,i_svc) !crop*100000 + harvest
		elseif (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)==2.)then
		CROP1(23,i_subas,lu_counter,tc_counter,i_svc)=CROP1(5,i_subas,lu_counter,tc_counter,i_svc)*100000.+ CROP1(13,i_subas,lu_counter,tc_counter,i_svc) !crop*100000 + harvest
		else 
		CROP1(24,i_subas,lu_counter,tc_counter,i_svc)=CROP1(5,i_subas,lu_counter,tc_counter,i_svc)*100000.+ CROP1(13,i_subas,lu_counter,tc_counter,i_svc) !crop*100000 + harvest
		end if
		
	    CROP1(12,i_subas,lu_counter,tc_counter,i_svc)=CROP1(12,i_subas,lu_counter,tc_counter,i_svc)+1.	!update cycle
		if (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)<4.) then
		CROP1(5,i_subas,lu_counter,tc_counter,i_svc)=croppatv(INT(CROP1(12,i_subas,lu_counter,tc_counter,i_svc))+1,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))*croppats(INT(CROP1(12,i_subas,lu_counter,tc_counter,i_svc))+1,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))	!take next crop
		CROP1(7,i_subas,lu_counter,tc_counter,i_svc)=0.		!reset development
		CROP1(8,i_subas,lu_counter,tc_counter,i_svc)=0.		!reset height
		CROP1(9,i_subas,lu_counter,tc_counter,i_svc)=0.		!reset LAI
		CROP1(10,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset roots
		if (CROP1(5,i_subas,lu_counter,tc_counter,i_svc)>0.) then
			CROP1(14,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset stage
		else
			CROP1(14,i_subas,lu_counter,tc_counter,i_svc)=0.
		end if
		CROP1(15,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset temperature sum
		CROP1(16,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset wrt
		CROP1(17,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset wst
		CROP1(18,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset wlv
		CROP1(19,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset wso
		CROP1(13,i_subas,lu_counter,tc_counter,i_svc)=0.   !reset harvest storage
		else
		CROP1(13:20,i_subas,lu_counter,tc_counter,i_svc)=0.
		CROP1(5:10,i_subas,lu_counter,tc_counter,i_svc)=0.
        end if
	END IF
END DO

!CROP1(:,i_subas,lu_counter,tc_counter,:)=CROP1(:,i_subas,lu_counter,tc_counter,:)
RETURN
END SUBROUTINE cropcontrols
