SUBROUTINE cropcontrolsA(CROP1,i_subas,lu_counter,tc_counter,act_day,onset,tcid_instance2,id_tc_type2)

use climo_h
use common_h
use hymo_h
use params_h
use time_h
use lake_h
use utils_h
use reservoir_h
use erosion_h


IMPLICIT NONE


REAL,INTENT(INOUT) ::	CROP1(30,subasin,maxsoter,maxterrain,maxsoil) 
INTEGER,INTENT(IN) ::	i_subas,lu_counter,tc_counter,id_tc_type2
INTEGER ::				act_day,onset,tcid_instance2,i_svc,i_lu,c1,kharifcount,rabicount,i_c,i,kharif,rabi,x1,x2,cs(13),e1,kharif1(3), rabi1(3)
REAL ::					crop(13,8),a1,b1,maxgain,dev,d1,cropsort(13,2)




				!conrad: debug
				if (isnan(CROP1(7,i_subas,lu_counter,tc_counter,1))) then
					write(*,*)'FATAL ERROR!!! in cropcontrol'
				end if



!period(2,i_subas,y_act)=onset

!debug conrad
!IF (act_day==14) THEN

IF (act_day==onset-14) THEN
!monsoon is comming: start deciding about what to plant!

	maxgain=MAXVAL(prices(:,2)-prices(:,1))

	DO i_svc=1,nbr_svc(tcid_instance2) !in each svc
		
		!give credits to most likely to chose crops
		kharifcount=0.
		rabicount=0.
		DO i_c=1,13
			!soil @ crop(:,1):
			if (decisionbaseC(10,i_c)==decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc))) .AND. (decisionbaseC(11,i_c)==decisionbaseS(3,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc))) .OR. decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))==0)) then
				crop(i_c,1)=1. !matching soil
			elseif (decisionbaseC(10,i_c)==decisionbaseS(3,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc))) .AND. decisionbaseC(11,i_c)==decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))) then
				crop(i_c,1)=0.9
			elseif (decisionbaseC(10,i_c)==decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc))) .AND. decisionbaseC(11,i_c)/=decisionbaseS(3,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))) then
				crop(i_c,1)=0.8
			elseif (decisionbaseC(11,i_c)==decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc))) .AND. decisionbaseC(10,i_c)==decisionbaseS(3,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))) then
				crop(i_c,1)=0.6
			elseif (decisionbaseC(11,i_c)==decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))) then
				crop(i_c,1)=0.5
			elseif (decisionbaseC(12,i_c)==decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc))) .AND. decisionbaseC(11,i_c)==decisionbaseS(3,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))) then
				crop(i_c,1)=0.4
			elseif (decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))==0) then
				crop(i_c,1)=0.
			else 
				crop(i_c,1)=0.2
			end if
			

			!veg @ crop(:,2):
			if (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==0) then
				crop(i_c,2)=0. !no cropping at all
			elseif (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==1 .AND. (i_c==6 .OR. i_c==9 .OR. i_c==10 .OR. i_c==7)) then
				crop(i_c,2)=1. !intensive cropping at 6,7,9,10
			elseif (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==1 .AND. (i_c==1 .OR. i_c==2 .OR. i_c==3 .OR. i_c==4 .OR. i_c==5 .OR. i_c==8 .OR. i_c==12)) then
				crop(i_c,2)=0.8 !intensive cropping at 1,2,3,4,5,8,12
			elseif (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==2 .AND. (i_c==1 .OR. i_c==2 .OR. i_c==3 .OR. i_c==4 .OR. i_c==5 .OR. i_c==8 .OR. i_c==11 .OR. i_c==12)) then
				crop(i_c,2)=1 !cropping at 1,2,3,4,5,8,11,12
			elseif (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==2 .AND. (i_c==6 .OR. i_c==9 .OR. i_c==10 .OR. i_c==7)) then
				crop(i_c,2)=0.7 !normal cropping at 6,7,9,10
			elseif (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==3 .AND. decisionbaseS(2,CROP1(4,i_subas,lu_counter,tc_counter,i_svc))>1 .AND. decisionbaseS(3,CROP1(4,i_subas,lu_counter,tc_counter,i_svc))>1) then
				crop(i_c,2)=0.6 !cropping at meager
			elseif (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==4 .AND. i_c==13) then
				crop(i_c,2)=1. !grass fits
			else 
				crop(i_c,2)=0.2
			end if


			!money gain @ crop(:,3):
			crop(i_c,3)=(prices(i_c,2)-prices(i_c,1))/maxgain !wheighted to max gain in year


			!weather anticipation @ crop(:,4):
			d1=sum(precip(act_day:act_day+160,i_subas))
			if (decisionbaseC(7,i_c)<d1-100 .AND. decisionbaseC(2,i_c)>1) then
				crop(i_c,4)=1.
			elseif (decisionbaseC(7,i_c)<d1 .AND. decisionbaseC(2,i_c)>1) then
				crop(i_c,4)=0.8
			elseif (decisionbaseC(7,i_c)<d1+100 .AND. decisionbaseC(2,i_c)>1) then
				crop(i_c,4)=0.5
			elseif (decisionbaseC(7,i_c)<d1-100 .AND. decisionbaseC(1,i_c)>1) then
				crop(i_c,4)=0.7
			elseif (decisionbaseC(7,i_c)<d1 .AND. decisionbaseC(1,i_c)>1) then
				crop(i_c,4)=0.5
			else 
				crop(i_c,4)=0.2
			end if

			
			!erosivity @ crop(:,5):
			crop(i_c,5)=(decisionbaseC(18,i_c)*slope(id_tc_type2))/10


			!fertility @ crop(:,6):
			if (decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))>MAXVAL(decisionbaseS(4,:))*0.75 .AND. decisionbaseC(9,i_c)==2) then
				crop(i_c,6)=1.
			elseif (decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))>MAXVAL(decisionbaseS(4,:))*0.6 .AND. decisionbaseC(9,i_c)>0) then
				crop(i_c,6)=1.
			elseif (decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))>300 .AND. decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))<=MAXVAL(decisionbaseS(4,:))*0.6) then
				crop(i_c,6)=0.7
			elseif (decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))>300 .AND. decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))<=MAXVAL(decisionbaseS(4,:))*0.6 .AND. decisionbaseC(9,i_c)==0) then
				crop(i_c,6)=0.7
			elseif (decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))>300 .AND. decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))<=MAXVAL(decisionbaseS(4,:))*0.6 .AND. decisionbaseC(9,i_c)==1) then
				crop(i_c,6)=0.3
			else 
			crop(i_c,6)=0.1
			end if
		
		!END DO !all crops
		
		!DO i_c=1,13
			!rescale all weights now!
		!	DO i=1,6
		!		crop(i_c,i)=crop(i_c,i)*(1/MAXVAL(crop(:,i)))
					!conrad debug:
					!if (crop(i_c,i)<=0.) then
						!somehow there is an error with the agent
					!end if
		!	END DO
		!END DO

		!DO i_c=1,13
			!summarize weights now
			! WARNING ! HERE it is possible to stear the agent's "concern" through emphasizing certain weights...
					  ! the agent will decide most likely for the crop with maximum value here
			!crop(i_c,7)=crop(i_c,1)*crop(i_c,2)  *  crop(i_c,4)  *   (crop(i_c,3)    *   (prices(i_c,2)/prices(i_c,1))/(MAXVAL(prices(:,2))/MINVAL(prices(:,1)))) *   crop(i_c,5)   *   crop(i_c,6)   *    1.-(decisionbaseC(13,i_c)*0.3)
			!            ^suiting the location^       ^weather^       ^money gain^        ^input capital^														  	   ^erosivity^		  ^fertility^	     ^penalty for labor intense^
		
			!8 almost full consideration
			!crop(i_c,7)=crop(i_c,1)*crop(i_c,2)  *  crop(i_c,4)  *   (crop(i_c,3)    *   (prices(i_c,2)/prices(i_c,1))/(MAXVAL(prices(:,2))/MINVAL(prices(:,1))))  *   crop(i_c,5)   *   crop(i_c,6) 
			
			!1 best local adaptation
			crop(i_c,7)=crop(i_c,1)*crop(i_c,2)   *    crop(i_c,5)   *   crop(i_c,6)
			
			!2 profit
			!crop(i_c,7)=crop(i_c,3)    *   (prices(i_c,2)/prices(i_c,1))/(MAXVAL(prices(:,2))/MINVAL(prices(:,1)))
			
			!3 location + weather
			!crop(i_c,7)=crop(i_c,1)*crop(i_c,2)  *  crop(i_c,4)

			!4 weather + erosion
			!crop(i_c,7)=crop(i_c,5)  *  crop(i_c,4)

			!5 weather + fertility
			!crop(i_c,7)=crop(i_c,4)  *  crop(i_c,6)

			!6 input + labor (risk of losses)
			!crop(i_c,7)=(1.-(decisionbaseC(13,i_c)*0.3))  *   (prices(i_c,2)/prices(i_c,1))/( MAXVAL(prices(:,2))/ MINVAL(prices(:,1)) )

			!7 inverse weather + profit
			!crop(i_c,7)=(1-crop(i_c,4))   *   crop(i_c,3)    *   (prices(i_c,2)/prices(i_c,1))/(MAXVAL(prices(:,2))/MINVAL(prices(:,1)))

			!9 weather adaptation only
			!crop(i_c,7)=crop(i_c,4)

			!check decision routine: there should always be an option for fallow land or similar conditions if the profit becomes too low and labor intense is high...
			!even other rules might be applicable here. it should be aimed on most realistic simulation of policy-private decision dependencies
			

			!unsuitable location for agriculture -> grass here
			if (i_c==13 .AND. & 
				((decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))==4 .OR. &
				  decisionbaseS(2,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))==0) .OR. &
				 decisionbaseS(3,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))==4 .OR. &
			     ( (decisionbaseV(2,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==4 .OR. &
			        decisionbaseV(3,INT(CROP1(3,i_subas,lu_counter,tc_counter,i_svc)))==4) .AND. &
				  decisionbaseS(4,INT(CROP1(4,i_subas,lu_counter,tc_counter,i_svc)))<200) .OR. &
				 slope(id_tc_type2)>15.)) then
				crop(i_c,7)=1
			end if
			
		END DO !all crops
		
		
		!get array of crop and weights
		cs=[1:13]
		cropsort(:,1)=[1:13]
		cropsort(:,2)=crop(:,7)
		!sort for weights
		x1=1
		i=1
		DO WHILE (x1>0)
			x2=0
			DO i=1,12
			if (cropsort(cs(i),2)>=cropsort(cs(i+1),2)) then
				cs(i)=cs(i)
			else
				d1=cs(i)
				cs(i)=cs(i+1)
				cs(i+1)=d1
				x2=x2+1
			end if
			END DO
			cropsort(:,:)=cropsort(cs,:)
			if (x2==0) x1=0
		END DO


		!set most liked crop as kharif and rabi
		kharif=99
		rabi=99
		kharif1(:)=0
		rabi1(:)=0
		i=1
		i_c=1
		DO WHILE (i<=3 .AND. i_c<=13)
			if (decisionbaseC(2,INT(cropsort(i_c,1)))==2) then
				kharif1(i)=INT(cropsort(i_c,1))
				i=i+1
			end if
			a1=i-1
			i_c=i_c+1
		END DO
		i=1
		i_c=1
		DO WHILE (i<=3 .AND. i_c<=13)
			if (decisionbaseC(3,INT(cropsort(i_c,1)))==2) then
				rabi1(i)=INT(cropsort(i_c,1))
				i=i+1
			end if
			b1=i-1
			i_c=i_c+1
		END DO

		
		!in case no crop was set yet...
		i=1
		if (SUM(kharif1)==0) then
		i_c=1
		DO WHILE (i<=3 .AND. i_c<=13)
			if (decisionbaseC(2,INT(cropsort(i_c,1)))==1) then 
				kharif1(i)=INT(cropsort(i_c,1))
				i=i+1
			end if
			a1=i-1
			i_c=i_c+1
		END DO
		end if
		
		i=1
		if (SUM(rabi1)==0) then
		i_c=1
		DO WHILE (i<=3 .AND. i_c<=13)
			if (decisionbaseC(3,INT(cropsort(i_c,1)))==1) then
				rabi1(i)=INT(cropsort(i_c,1))
				i=i+1
			end if
			b1=i-1
			i_c=i_c+1
		END DO
		end if
		
		if (a1>1) then
			CALL RANDOM_SEED
			CALL RANDOM_NUMBER(d1)
			c1=INT(a1)*d1
			if (c1<1) c1=1
			kharif=kharif1(INT(c1))
		elseif (a1==1) then
			kharif=kharif1(1)
		else
			kharif=13
		end if
		if (b1>1) then
			CALL RANDOM_SEED
			CALL RANDOM_NUMBER(d1)
			c1=INT(b1)*d1
			if (c1<1) c1=1
			rabi=rabi1(INT(c1))
		elseif (b1==1) then
			rabi=rabi1(1)
		else
			rabi=13
		end if

		!just in case to be consistent with other subroutines
		if (kharif==0 .OR. kharif>13) kharif=13
		if (rabi==0 .OR. rabi>13) rabi=13
		CROP1(25,i_subas,lu_counter,tc_counter,i_svc)=REAL(kharif)
		CROP1(26,i_subas,lu_counter,tc_counter,i_svc)=REAL(rabi)


		!seeding day
		a1=0.
		b1=21.
		CALL RANDOM_SEED
		CALL RANDOM_NUMBER(d1)
		c1=INT(a1+(b1-a1)*d1)
		CROP1(27,i_subas,lu_counter,tc_counter,i_svc)=REAL(c1)


	END DO !each svc
END IF







IF (act_day>onset-6 .AND. act_day<onset+15) THEN
	DO i_svc=1,nbr_svc(tcid_instance2)
	if (act_day==onset-7+INT(CROP1(27,i_subas,lu_counter,tc_counter,i_svc))) then
		CROP1(7,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset development
		CROP1(8,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset height
		CROP1(9,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset LAI
		CROP1(10,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset roots
		CROP1(12,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset cycle
		CROP1(14,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset stage
		CROP1(11,i_subas,lu_counter,tc_counter,i_svc)=alb(CROP1(3,i_subas,lu_counter,tc_counter,i_svc),1)	!reset albedo
		CROP1(5,i_subas,lu_counter,tc_counter,i_svc)=CROP1(25,i_subas,lu_counter,tc_counter,i_svc)	!reset crop to kharif
	end if
	END DO
END IF

!check for harvested crops, refresh parameters LAI, height, roots, albedo with own values
DO i_svc=1,nbr_svc(tcid_instance2)
	IF (CROP1(14,i_subas,lu_counter,tc_counter,i_svc)==9.) THEN
		
		!store harvest: 1:crop 2:amount kg/ha
		!IF (i_subas==6.AND.lu_counter==2.AND.tc_counter==1) write(*,*)'stoppop'
		if (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)==1.) then
		CROP1(22,i_subas,lu_counter,tc_counter,i_svc)=CROP1(5,i_subas,lu_counter,tc_counter,i_svc)*100000.+ CROP1(13,i_subas,lu_counter,tc_counter,i_svc) !crop*100000 + harvest
		elseif (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)==2.)then
		CROP1(23,i_subas,lu_counter,tc_counter,i_svc)=CROP1(5,i_subas,lu_counter,tc_counter,i_svc)*100000.+ CROP1(13,i_subas,lu_counter,tc_counter,i_svc) !crop*100000 + harvest
		else 
		CROP1(24,i_subas,lu_counter,tc_counter,i_svc)=CROP1(5,i_subas,lu_counter,tc_counter,i_svc)*100000.+ CROP1(13,i_subas,lu_counter,tc_counter,i_svc) !crop*100000 + harvest
		end if
		
	    CROP1(12,i_subas,lu_counter,tc_counter,i_svc)=CROP1(12,i_subas,lu_counter,tc_counter,i_svc)+1.	!update cycle
		if (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)==2.) then
			CROP1(5,i_subas,lu_counter,tc_counter,i_svc)=CROP1(26,i_subas,lu_counter,tc_counter,i_svc) !take rabi crop
			CROP1(7,i_subas,lu_counter,tc_counter,i_svc)=0.		!reset developmentr
			CROP1(8,i_subas,lu_counter,tc_counter,i_svc)=0.		!reset height
			CROP1(9,i_subas,lu_counter,tc_counter,i_svc)=0.		!reset LAI
			CROP1(10,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset roots
			if (CROP1(5,i_subas,lu_counter,tc_counter,i_svc)>0.) then
				CROP1(14,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset stage
			else
				CROP1(14,i_subas,lu_counter,tc_counter,i_svc)=0.
			end if
			CROP1(15,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset temperature sum
			CROP1(16,i_subas,lu_counter,tc_counter,i_svc)=1.	!reset wrt
			CROP1(17,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset wst
			CROP1(18,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset wlv
			CROP1(19,i_subas,lu_counter,tc_counter,i_svc)=0.	!reset wso
			CROP1(13,i_subas,lu_counter,tc_counter,i_svc)=0.   !reset harvest storage
		elseif (CROP1(12,i_subas,lu_counter,tc_counter,i_svc)==2.) then

			!harvest.out after all rabi crops are harvested...

		else
		CROP1(13:20,i_subas,lu_counter,tc_counter,i_svc)=0.
		CROP1(5:10,i_subas,lu_counter,tc_counter,i_svc)=0.
        end if
	END IF
END DO

RETURN
END SUBROUTINE cropcontrolsA
