%meteodata input generator
%version 0.95 conrad temperature check for NaNs -> use long year means instead
%                    precipitation check NaNs -> use zero instead

%version 0.9 conrad
%be aware of dirty programming style ;)

clear
%give start and end date
xstart=datenum(1992, 01, 01);%YYYY MM DD
xend=datenum(1997, 04, 30);


%alirajpur data
maxt=dlmread('maxtemp','\t');
mint=dlmread('mintemp','\t');
humid=dlmread('humid','\t');

%structure: (year,month) and @ humid (year, month morning afternoon...)

indore=dlmread('indore','\t');
m=length(indore(1,:))+1;
for i=1:length(indore(:,1))
indore(i,m)=datenum(indore(i,1), indore(i,2), indore(i,3));
end

%dlmwrite('indoremod',indore,'delimiter', '\t', 'precision', '%.0f');

prec=dlmread('prec_all.csv',';');%read precipitation data
m=length(prec(1,:))+1;
for i=1:length(prec(:,1))
    if prec(i,3) < 10
        prec(i,3)=prec(i,3)+2000;
    else prec(i,3)=prec(i,3)+1900;
    end
prec(i,m)=datenum(prec(i,3), prec(i,1), prec(i,2));
end

jhabuaw=dlmread('jhabuaKVK','\t');%get weekly data from KVK-station jahbua
%generate daily data
for i=1:length(jhabuaw(:,1))
j=((i-1)*7)+1;
jhabua(j,1)=datenum(jhabuaw(i,2), 1, 1)+((jhabuaw(i,1)-1)*7);%datestamp
jhabua(j+1,1)=jhabua(j,1)+1;
jhabua(j+2,1)=jhabua(j,1)+2;
jhabua(j+3,1)=jhabua(j,1)+3;
jhabua(j+4,1)=jhabua(j,1)+4;
jhabua(j+5,1)=jhabua(j,1)+5;
jhabua(j+6,1)=jhabua(j,1)+6;

jhabua(j:j+6,2)=jhabuaw(i,3);%max temp
jhabua(j:j+6,3)=jhabuaw(i,4);%min temp
end

%transfer daily prec data of jhabua to jhabua matrix
m=length(prec(1,:));
for i=1:length(jhabua(:,1))
    idx=find(prec(:,m)==jhabua(i,1));
    if idx
        jhabua(i,4)=prec(idx,4);
    else jhabua(i,4)=0;
    end
end

%analyse temperature differences indore-jhabua
m=length(indore(1,:));
for i=1:length(jhabua(:,1))
    idx=find(indore(:,m)==jhabua(i,1));
    if idx
    dif_tmax(i)=indore(idx,4)-jhabua(i,2);
    dif_tmin(i)=indore(idx,5)-jhabua(i,3);
    end
end


% %plot differences
% figure(4);
% hold off
% plot(dif_tmax,'Color','blue')
% hold on
% plot(dif_tmin,'Color','red')
% xlabel(['day']);
% ylabel(['K']);
% title(['Daily temperature differences Indore-Jhabua - tmax (blue), tmin (red)']);


%get subbasins and distances from grass:
%run r.distance -l maps=SUBBASINS_LUMP,prec_stations > distances.txt
%1=megnaghar, 2=jhabua, 3=ranapur, 4=udaighar
sub_ini=dlmread('distances.txt','\t');
subs(:,1)=unique(sub_ini(:,1));
for i=1:length(subs(:,1))
    idx=find(sub_ini(:,1)==subs(i));
    refsum=sum(sub_ini(idx,3));
    for k=1:3
        j=idx(k);
        subs(i,k+1)=sub_ini(j,3)/refsum;
    end
    if sum(subs(i,2:4))>1.05 || sum(subs(i,2:4))<0.95
        disp(['there was an error precessing weights at subbasin ',num2str(subs(i,1))])
        disp(['weights are ',num2str(subs(i,2)),num2str(subs(i,3)),num2str(subs(i,4))])%,num2str(subs(i,5))])
    end
end
        
    
%####TEMPERATURE.DAT######
fid=fopen('temperature.dat','w+');       
fprintf(fid,'Daily average temperature (in degrees Celcius) for each subbasin, ordered according to Map-IDs\n');
fprintf(fid,'Date	No. of days');
for j=1:length(subs(:,1))
    fprintf(fid,', Subbasin_ID');
end
fprintf(fid,'\n');
fprintf(fid,'0	0	');
for j=1:length(subs(:,1))
    fprintf(fid,[num2str(subs(j,1)),'	']);
end
fprintf(fid,'\n');

m=length(indore(1,:));
for i=xstart:xend
    idx=find(jhabua(:,1)==i);
    if idx | isnan(mean(mean([jhabua(idx,2) jhabua(idx,3)])))<1
        temp=mean([jhabua(idx,2) jhabua(idx,3)]);%no spatial distribution for temperature means
    else idx=find(indore(:,m)==i);
        temp=mean([indore(idx,4) indore(idx,5)]);%takes indore data if jahbua observations are missing
    end
    if isnan(temp)
        idx=str2num(datestr(i,'mm'));
        temp=mean(mean([maxt(:,idx) mint(:,idx)]));
    end
        
    fprintf(fid,[datestr(i,'ddmmyyyy'),'    ',num2str(i-xstart+1),' ']);
    for j=1:length(subs(:,1))
    fprintf(fid,[num2str(temp,'%.1f'),'  ']);
    end
    fprintf(fid,'\n');
end
fclose(fid);


%####RAIN_DAILY.DAT########
fid=fopen('rain_daily.dat','w+');       
fprintf(fid,'Daily average precipitation [mm/d] for each subbasin, ordered according to Map-IDs\n');
fprintf(fid,'Date	No. of days');
for j=1:length(subs(:,1))
    fprintf(fid,', Subbasin_ID');
end
fprintf(fid,'\n');
fprintf(fid,'0	0	');
for j=1:length(subs(:,1))
    fprintf(fid,[num2str(subs(j,1)),'	']);
end
fprintf(fid,'\n');

m=length(prec(1,:));
for i=xstart:xend
    idx=find(prec(:,m)==i);
    fprintf(fid,[datestr(i,'ddmmyyyy'),'    ',num2str(i-xstart+1),' ']);
    for j=1:length(subs(:,1))
        if isnan(prec(idx,9))
            prec(idx,9)=0.0;
        elseif isnan(prec(idx,4))
            prec(idx,4)=0.0;
        elseif isnan(prec(idx,6))
            prec(idx,6)=0.0;
        end
    rain=subs(j,2)*prec(idx,9)+subs(j,3)*prec(idx,4)+subs(j,4)*prec(idx,6);%+subs(j,5)*prec(idx,7);%distribute measured rain according to weights from recorded stations
    fprintf(fid,[num2str(rain,'%.1f'),'  ']);
    end
    fprintf(fid,'\n');
end
fclose(fid);
    



% %get monthly means from indore data
% for i=1:12
% idx=find(indore(:,2)==i);
% maxti(i)=mean(indore(idx,4));
% minti(i)=mean(indore(idx,5));
% humsort=sort(indore(idx,6));
% endidx=find(isnan(humsort));
% if endidx
%     humidi(i)=mean(humsort(1:endidx-1));
% else humidi(i)=mean(indore(idx,6));
% end
% end
% 
% %plot max temp
% figure(1);
% hold off
% plot(median(maxt),'Color','blue')
% hold on
% plot(maxti,'Color','red')
% xlabel(['Month']);
% ylabel(['C']);
% title(['Mean Monthly Max Temperatures Alirajpur `56-`80 (blue) Indore `92-`02 (red)']);
% 
% 
% %plot min temp
% figure(2);
% hold off
% plot(median(mint),'Color','blue')
% hold on
% plot(minti,'Color','red')
% xlabel(['Month']);
% ylabel(['C']);
% title(['Mean Monthly Min Temperatures Alirajpur `56-`80 (blue) Indore `92-`02 (red)']);
% 
% 
% %plot humidity
% figure(3);
% hold off
% humplot=median(humid);
% humplot=humplot([1 3 5 7 9 11 13 15 17 19 21 23]);
% plot(humplot,'Color','blue')
% hold on
% plot(humidi,'Color','red')
% xlabel(['Month']);
% ylabel(['rel. %']);
% title(['Mean Monthly Humidity Alirajpur `56-`80 (blue) Indore `92-`02 (red)']);

%####RADIATION.DAT########
fid=fopen('radiation.dat','w+');       
fprintf(fid,'Daily average shortwave radiation [in W/m2] for each subbasin, ordered according to Map-IDs\n');
fprintf(fid,'Date	No. of days');
for j=1:length(subs(:,1))
    fprintf(fid,', Subbasin_ID');
end
fprintf(fid,'\n');
fprintf(fid,'0	0	');
for j=1:length(subs(:,1))
    fprintf(fid,[num2str(subs(j,1)),'	']);
end
fprintf(fid,'\n');

%incoming shortwave radiation
LAT=22.4;
S=1370;%W/m^2; Kyle 1985

% ## CALCULATION OF LOOK-UP TABLE FOR S0 #####
%S0 = Extraterrestial Radiation in MJ*m^2*d^1 for one year
d=1;
for d=1:365
    decl = 0.4093 * sin(((2*pi)/365)*d - 1.405);
    dr = 1 + 0.033 * cos((2*pi)/(365*d));
    t= acos(-tan(LAT) * tan(decl));
    S0(d)= 15.392 * dr * (t * sin(LAT) * sin(decl) + cos(LAT) * cos(decl) * sin(t));
end

for i=xstart:xend
    x=datestr(i,'yyyy');
    day=i-datenum(str2num(x),1,1)+1;
    if day>365
        day=365;
    end
    fprintf(fid,[datestr(i,'ddmmyyyy'),'    ',num2str(i-xstart+1),' ']);
    for j=1:length(subs(:,1))
    fprintf(fid,[num2str((S0(day)*-1e06)/86400,'%.1f'),'  ']);
    end
    fprintf(fid,'\n');
end
fclose(fid);


% %modified Hargreaves
% gammay=2.9;
% deltay=9.6;
% betay=15.4;
% w1=0.5;
% w2=1-w1;
% mi=length(indore(1,:));
% mp=length(prec(1,:));
% %### CALCULATION #######
% for date=xstart:xend    
%     x=datestr(date,'yyyy');
%     day=date-datenum(x,1,1)+1;
%     idx=find(jhabua(:,1)==date);
%     idxp=find(prec(:,mp)==date);
%     if idx
%         Tmax=jhabua(idx,2);
%         Tmin=jhabua(idx,3);
%     else idx=find(indore(:,mi)==date);
%         Tmax=indore(idx,4);
%         Tmin=indore(idx,5);
%     end
%     
%     for j=1:length(subs(:,1))
%     rain=subs(j,2)*prec(idxp,9)+subs(j,3)*prec(idxp,4)+subs(j,4)*prec(idxp,6)+subs(j,5)*prec(idxp,7);%distribute measured rain according to weights from recorded stations
%     
%     TP = (Tmax-Tmin) - (0.0123 * rain);
%     if TP<0
%         TP=0;
%     end
%     Tmean=mean([Tmax(i) Tmin(i)]);
%     %after chuanyan/droogers
%     HET = 0.0013 * S0(day) * (exp((Tmean/gammay)-deltay) + (w1*Tmax + w2*Tmin) + betay) * ((TP) ^ 0.76);%introduced weighted means
%     %convert HET in Humidity
%     end
% end

%####HUMIDITY.DAT########
%take longterm monthly medians for daily data...
fid=fopen('humidity.dat','w+');       
fprintf(fid,'Daily average humidity [in per cent] for each subbasin, ordered according to Map-IDs\n');
fprintf(fid,'Date	No. of days');
for j=1:length(subs(:,1))
    fprintf(fid,', Subbasin_ID');
end
fprintf(fid,'\n');
fprintf(fid,'0	0	');
for j=1:length(subs(:,1))
    fprintf(fid,[num2str(subs(j,1)),'	']);
end
fprintf(fid,'\n');

humplot=median(humid);
humplot=humplot([1 3 5 7 9 11 13 15 17 19 21 23]);

for i=xstart:xend
    fprintf(fid,[datestr(i,'ddmmyyyy'),'    ',num2str(i-xstart+1),' ']);
    idx=str2num(datestr(i,'mm'));
    humid=humplot(idx);
    for j=1:length(subs(:,1))
    fprintf(fid,[num2str(humid,'%.1f'),'  ']);
    end
    fprintf(fid,'\n');
end
fclose(fid);


%###RAINY_SEASON.DAT#########
%use floating windows to scan all considered years
%use jhabua station as reference
a=str2num(datestr(xstart,'yyyy'));
b=str2num(datestr(xend,'yyyy'));
i=0;
mi=length(indore(1,:));
for c=a:b
    i=i+1;
    years(i)=a+(i-1);
end

for i=1:length(years)
    %find monsoon onset
    idx=find(jhabua(:,1)==datenum(years(i), 4, 30),1);
    if idx
        rainswitch=0;
        raintotal=0;
        while rainswitch<2 & raintotal<60
            idx=idx+1;
            rainswitchx=zeros(1,10);
            if idx
            for j=1:10
                    if isnan(jhabua(idx+(j-1),4))
                        jhabua(idx+(j-1),4)=0;
                    end
                %if jhabua(idx+(j-1),4)>0
                    rainswitchx(j)=jhabua(idx+(j-1),4)/jhabua(idx+(j-1),4);
                    if isnan(rainswitchx(j))
                        rainswitchx(j)=0;
                    end
                %else rainswitchx=0;
                %end
            end
            end
            rainswitch=sum(rainswitchx);
            raintotal=sum(jhabua(idx:idx+9,4));
            if rainswitch>1 & raintotal>60
                disp('ONSET FOUND')
                break
            end
        end
        mset(i,1)=jhabua(idx+9,1)-datenum(years(i), 1, 1);%onset day
    else idx=find(indore(:,mi)==datenum(years(i), 4, 30),1);
        rainswitch=0;
        raintotal=0;
        while rainswitch<2 && raintotal<60
            idx=idx+1;
            rainswitchx=zeros(1,10);
            if idx
            for j=1:10
                %if indore(idx+(j-1),mi)
                    if isnan(indore(idx+(j-1),4))
                        indore(idx+(j-1),4)=0;
                    end
                    rainswitchx(j)=indore(idx+(j-1),mi)/indore(idx+(j-1),mi);
                    if isnan(rainswitchx(j))
                        rainswitchx(j)=0;
                    end
                %else rainswitchx=0;
                %end
            end
            end
            rainswitch=sum(rainswitchx);
            raintotal=sum(indore(idx:idx+9,mi));
            if rainswitch>1 && raintotal>60
                break
            end
        end
        mset(i,1)=indore(idx+9,mi)-datenum(years(i), 1, 1);%onset day
    end

    %find monsoon offset
    idx=find(jhabua(:,1)==datenum(years(i), 11, 30),1);
    if idx
        rainswitch=0;
        raintotal=0;
        while rainswitch<1 && raintotal<20
            rainswitchx=zeros(1,10);
            if idx
            idx=idx-1;
            for j=1:10
                %if jhabua(idx-(j-1),4)
                    if isnan(jhabua(idx-(j-1),4))
                        jhabua(idx-(j-1),4)=0;
                    end
                    rainswitchx(j)=jhabua(idx-(j-1),4)/jhabua(idx-(j-1),4);
                    if isnan(rainswitchx(j))
                        rainswitchx(j)=0;
                    end
                %else rainswitchx=0;
                %end
            end
            end
            rainswitch=sum(rainswitchx);
            raintotal=sum(jhabua(idx:idx-9,4));
            if rainswitch>1 && raintotal>20
                break
            end
        end
        mset(i,2)=jhabua(idx-9,1)-datenum(years(i), 1, 1);%offset day

    else idx=find(indore(:,mi)==datenum(years(i), 11, 30),1);
        rainswitch=0;
        raintotal=0;
        while rainswitch<1 && raintotal<20
            rainswitchx=zeros(1,10);
            if idx
            idx=idx+1;
            for j=1:10
               % if indore(idx+(j-1),mi)
                    if isnan(indore(idx+(j-1),4))
                        indore(idx+(j-1),4)=0;
                    end
                    rainswitchx(j)=indore(idx-(j-1),mi)/indore(idx-(j-1),mi);
                    if isnan(rainswitchx(j))
                        rainswitchx(j)=0;
                    end
               % else rainswitchx=0;
               % end
            end
            end
            rainswitch=sum(rainswitchx);
            raintotal=sum(indore(idx:idx+9,mi));
            if rainswitch>1 && raintotal>20
                break
            end
        end
        mset(i,2)=indore(idx-9,mi)-datenum(years(i), 1, 1);%offset day
    end

end

fid=fopen('rainy_season.dat','w+');
fprintf(fid,'Specification of the rainy season (per year)\n');
fprintf(fid,'for the interpolation of temporal distribution of vegetation characteristics (Rootdepth,height,lai,albedo)\n');
fprintf(fid,'Subbasin	Year    (Start-30)  Startday    Endday  (End+30)\n');
for j=1:length(years)
for i=1:length(subs)
    fprintf(fid,[num2str(subs(i),'%.0f'),'   ',num2str(years(j),'%.0f'),'    ',num2str(mset(j,1)-30,'%.0f'),'    ',num2str(mset(j,1),'%.0f'),'    ',num2str(mset(j,2)-30,'%.0f'),'    ',num2str(mset(j,2)+30,'%.0f'),'\n']);
end
end
fclose(fid);