clear
%check dis94
wasa_dir='u:/conrad/wasa_now/';   %directory that holds wasa files (end with slash)
lump_dir='../LUMP_now/';   %directory that holds lump files (end with slash)

DISfile=[wasa_dir 'output/River_Flow.out']; %file containing daily river flow for all subs m3/s
PRECfile=[wasa_dir 'input/Time_series/rain_daily.dat']; %file containing daily precipitation for all subs

%these files need to be prepared before
GAUGEfile=[lump_dir 'disgauge.dat']; %file containing daily discharge from whole basin

PREC=textread(PRECfile,'','headerlines',2);%precipitation: first 2 lines are IDs, first 2 columns are date
DIS=textread(DISfile,'','headerlines',2);%discharge: first 2 lines are IDs, first 2 columns are date; river flow m3/d for each sub
GAUGE=textread(GAUGEfile,'','headerlines',1);%measured discharge from whole basin, day, month, year, hight, discharge [m3/d]
GAUGE94=textread('mod_dailydis94.txt','','headerlines',1);%daily discharge at mod gauge 94
GAUGE6h=textread('mod_dis92_96_6h.dat','','headerlines',1);%daily discharge at mod gauge 94

%get date code
n=length(GAUGE(1,:))+1;
for i=1:length(GAUGE(:,1))
    GAUGE(i,n)=datenum([GAUGE(i,3) GAUGE(i,2) GAUGE(i,1)]);
end
m=length(PREC(1,:))-1;
for i=1:length(PREC(:,1))
    PREC(i,m+1)=datenum(double([(PREC(i,1)-(int32(PREC(i,1)/10000)*10000)) (int32(PREC(i,1)/10000)-(100*int32(PREC(i,1)/1000000))) int32(PREC(i,1)/1000000)]));
end
l=length(DIS(1,:));
for i=1:length(DIS(:,1))
    DIS(i,l+1)=datenum([DIS(i,1) 1 1])+DIS(i,2);
end
o=length(GAUGE94(1,:))+1;
for i=1:length(GAUGE94(:,1))
    GAUGE94(i,o)=datenum([GAUGE94(i,3) GAUGE94(i,2) GAUGE94(i,1)]);
end
p=length(GAUGE6h(1,:))+1;
for i=1:length(GAUGE6h(:,1))
    GAUGE6h(i,p)=datenum([GAUGE6h(i,3) GAUGE6h(i,2) GAUGE6h(i,1) GAUGE6h(i,4) 1 1]);
end



for i=1:length(GAUGE6h(:,1))
    idx=find(DIS(:,l+1)==int32(GAUGE6h(i,p)));
    checker(1,i)=GAUGE6h(i,6);
    checker(2,i)=DIS(idx,l);
    idx=find(PREC(:,m+1)==int32(GAUGE6h(i,p)));
    checker(3,i)=mean(PREC(idx,3:m));
end

%daily version to compare
% for i=1:length(GAUGE94(:,1))
%     idx=find(DIS(:,l+1)==GAUGE94(i,o));
%     checker1(1,i)=GAUGE94(i,4);
%     checker1(2,i)=DIS(idx,l);
%     idx=find(PREC(:,m+1)==GAUGE94(i,o));
%     checker1(3,i)=mean(PREC(idx,3:m));
% end


%mass calculation from 6h disgauge time series
firstt=GAUGE6h(1,p);
lastt=GAUGE6h(length(GAUGE6h(:,1)),p);

DISMASS6h=zeros(4,(lastt-firstt)*4);
for i=2:length(DISMASS6h(1,:))
    DISMASS6h(1,i)=firstt+i/4;
    jump1=0;
    jump2=0;
    idx1=find(GAUGE6h(:,p)==DISMASS6h(1,i)-1);
%     idx2=find(GAUGE6h(:,p)==DISMASS6h(1,i)-0.25);
    
    if isempty(idx1) || isnan(GAUGE6h(idx1,6))
%         jump1=1;
%     end
%     while isempty(idx1)% || isnan(GAUGE6h(idx1,6))
%         idx1=find(GAUGE6h(:,p)==DISMASS6h(1,i)+jump1*0.25);
%         jump1=jump1+1;
%     end
%     
%     if isempty(idx2) || isnan(GAUGE6h(idx2,6))
%         jump2=2;
%     end
%     while isempty(idx2) || isnan(GAUGE6h(idx2,6))
%         idx2=find(GAUGE6h(:,p)==DISMASS6h(1,i)-jump2*0.25);
%         jump2=jump2+1;
%     end
%    if isnan(GAUGE6h(idx1,6))
        flow1=0;
%     else if jump1>0 && jump2==0
%             flow1=GAUGE6h(idx1,6)+ (jump1-1)*(GAUGE6h(idx1,6)-DISMASS6h(2,i-1))/jump1;
%          elseif jump1>0 && jump2>0
%             flow1=GAUGE6h(idx1,6)+ (jump1-1)*(GAUGE6h(idx1,6)-DISMASS6h(2,i-1))/(jump1+jump2-2);
         else flow1=GAUGE6h(idx1,6);
%         end
    end
%     if jump2>0 && jump1==0
%         flow2=GAUGE6h(idx2,6)+ (jump2-2)*(GAUGE6h(idx2,6)-GAUGE(idx1,6))/(jump2-1);
%     elseif jump2>0 && jump1>0
%         flow2=GAUGE6h(idx2,6)+ (jump2-2)*(GAUGE6h(idx2,6)-GAUGE(idx1,6))/(jump2+jump1-2);
%     else flow2=GAUGE6h(idx2,6);
%     end
    DISMASS6h(2,i)=flow1;
    DISMASS6h(3,i)=(flow1*6*3600) + ((DISMASS6h(2,i-1)-flow1)*6*3600*0.5);
    DISMASS6h(4,i)=DISMASS6h(3,i)+DISMASS6h(4,i-1);
end

%drag precipitation and calculated discharge into 6h matrix
DISSIM6h=zeros(7,(lastt-firstt)*4);
for i=2:length(DISSIM6h(1,:))
    idx=find(DIS(:,l+1)==int32(DISMASS6h(1,i)));
    DISSIM6h(1,i)=DISMASS6h(1,i);
    DISSIM6h(2,i)=DIS(idx,l);
    DISSIM6h(3,i)=(DIS(idx,l)*6*3600) + ((DISSIM6h(2,i-1)-DIS(idx,l))*6*3600*0.5);
    DISSIM6h(4,i)=DISSIM6h(3,i)+DISSIM6h(4,i-1);  
    idx=find(PREC(:,m+1)==int32(DISMASS6h(1,i)));
    DISSIM6h(5,i)=mean(PREC(idx,3:m));
    DISSIM6h(6,i)=DISSIM6h(5,i)*512*250;
    DISSIM6h(7,i)=DISSIM6h(6,i)+DISSIM6h(7,i-1);
end

%cumulative
for i=1:length(GAUGE6h(:,1))
    if i==1
    idx=find(DIS(:,l+1)==int32(GAUGE6h(i,p)));
    checker1(1,i)=GAUGE6h(i,6);
    checker1(2,i)=DIS(idx,l);
    idx=find(PREC(:,m+1)==int32(GAUGE6h(i,p)));
    checker1(3,i)=mean(PREC(idx,3:m));
    else idx=find(DIS(:,l+1)==int32(GAUGE6h(i,p)));
        if isnan(GAUGE6h(i,6))
            checker1(1,i)=checker1(1,i-1);
        else checker1(1,i)=GAUGE6h(i,6)+checker1(1,i-1);
        end
    checker1(2,i)=DIS(idx,l)+checker1(2,i-1);
    idx=find(PREC(:,m+1)==int32(GAUGE6h(i,p)));
    checker1(3,i)=mean(PREC(idx,3:m))+checker1(3,i-1);
    end
end

% %cut out zeros
% idxs=0;
% for i=1:length(DISSIM6h(1,:))
%     if DISMASS6h(2,i)>0 %&& idxs<500
%         idxs=idxs+1;
%         DISMASScut(1,idxs)=DISMASS6h(1,i);
%         DISMASScut(2,idxs)=DISMASS6h(2,i);
%         DISMASScut(3,idxs)=DISMASS6h(3,i);
%         DISMASScut(4,idxs)=DISMASS6h(4,i);
%         DISSIMcut(1,idxs)=DISSIM6h(1,i);
%         DISSIMcut(2,idxs)=DISSIM6h(2,i);
%         DISSIMcut(3,idxs)=DISSIM6h(3,i);
%         DISSIMcut(4,idxs)=DISSIM6h(4,i);
%         DISSIMcut(5,idxs)=DISSIM6h(5,i);
%         DISSIMcut(6,idxs)=DISSIM6h(6,i);
%         DISSIMcut(7,idxs)=DISSIM6h(7,i);
%     end
% end
 
%stats for cutted ts
%nash sutcliffe
% 
% MSEo=0;
% so2o=0;
% Bo=mean(DISSIMcut(2,:))-mean(DISMASScut(:,2));
% d1o=zeros(1,length(DISSIMcut(1,:)));
% for i=1:length(DISSIMcut(1,:))
%     %MSEo=(DISMASS6h(2,i)-DISSIM6h(2,i))^2+MSEo;
%     so2o=(DISSIMcut(2,i)-mean(DISMASScut(2,:)))^2+so2o;
%     d1o(i)=(DISSIMcut(2,i)-DISMASScut(2,i))^2;
% end
% MSEo=mean(d1o);
% so2o=so2o/length(DISSIMcut(1,:));
% Eo=1-MSEo/var(DISMASScut(2,:));
% ISEo=sqrt(mean(d1o))/mean(DISMASScut(2,:));
% RS2o=1-(MSEo/(var(DISMASScut(2,:))+mean(DISMASScut(2,:))));
% a=cov(DISMASScut(2,:),DISSIMcut(2,:));
% Ro=a(1,2)/(var(DISMASScut(2,:))*var(DISSIMcut(2,:)));
% 
% disp(['bla' num2str(a)])


% %get 3 day means
% DISMASS3d=zeros(4,length(DISSIM6h(1,:)));
% DISSIM3d=zeros(7,length(DISSIM6h(1,:)));
% for i=2:length(DISSIM6h(1,:))-1
%         DISMASS3d(1,i)=DISMASS6h(1,i);
%         DISMASS3d(2,i)=mean(DISMASS6h(2,i-1:i+1));
%         DISMASS3d(3,i)=mean(DISMASS6h(3,i-1:i+1));
%         DISMASS3d(4,i)=mean(DISMASS6h(4,i-1:i+1));
%         DISSIM3d(1,i)=DISSIM6h(1,i);
%         DISSIM3d(2,i)=mean(DISSIM6h(2,i-1:i+1));
%         DISSIM3d(3,i)=mean(DISSIM6h(3,i-1:i+1));
%         DISSIM3d(4,i)=mean(DISSIM6h(4,i-1:i+1));
%         DISSIM3d(5,i)=mean(DISSIM6h(5,i-1:i+1));
%         DISSIM3d(6,i)=mean(DISSIM6h(6,i-1:i+1));
%         DISSIM3d(7,i)=mean(DISSIM6h(7,i-1:i+1));
%     
% end
%  
% %stats for 3 day mean ts
% %nash sutcliffe
% 
% MSEo=0;
% so2o=0;
% Bo=mean(DISSIM3d(2,:))-mean(DISMASS3d(:,2));
% d1o=zeros(1,length(DISSIM3d(1,:)));
% d2o=zeros(1,length(DISSIM3d(1,:)));
% for i=1:length(DISSIM3d(1,:))
%     MSEo=(DISMASS3d(2,i)-DISSIM6h(2,i))^2+MSEo;
%     so2o=(DISSIM3d(2,i)-mean(DISMASS3d(2,:)))^2+so2o;
%     d1o(i)=(DISSIM3d(2,i)-DISMASS3d(2,i))^2;
%     d2o(i)=((DISMASS3d(2,i)-mean(DISMASS3d(2,:)))/var(DISMASS3d(2,:)))*((DISSIM3d(2,i)-mean(DISSIM3d(2,:)))/var(DISSIM3d(2,:)));
% end
% %MSEo=mean(d1o);
% %so2o=so2o/length(DISSIM3d(1,:));
% Eo=1-MSEo/so2o;
% ISEo=sqrt(mean(d1o))/mean(DISMASS3d(2,:));
% RS2o=1-(MSEo/(var(DISMASS3d(2,:))+mean(DISMASS3d(2,:))));
% a=cov(DISMASS3d(2,:),DISSIM3d(2,:));
% Ro=a(1,2)/(var(DISMASS3d(2,:))*var(DISSIM3d(2,:)));
% Ro2=mean(d2o);
% 
% disp(['bla' num2str(a)])


%get 3 day means
DISMASS3d=zeros(4,length(DISSIM6h(1,:))/12);
DISSIM3d=zeros(7,length(DISSIM6h(1,:))/12);
for i=2:length(DISSIM3d(1,:))-1
    ia=i*4
        DISMASS3d(1,i)=DISMASS6h(1,ia);
        DISMASS3d(2,i)=mean(DISMASS6h(2,ia-6:ia+6));
        DISMASS3d(3,i)=mean(DISMASS6h(3,ia-6:ia+6));
        DISMASS3d(4,i)=mean(DISMASS6h(4,ia-6:ia+6));
        DISSIM3d(1,i)=DISSIM6h(1,ia);
        DISSIM3d(2,i)=mean(DISSIM6h(2,ia-6:ia+6));
        DISSIM3d(3,i)=mean(DISSIM6h(3,ia-6:ia+6));
        DISSIM3d(4,i)=mean(DISSIM6h(4,ia-6:ia+6));
        DISSIM3d(5,i)=mean(DISSIM6h(5,ia-6:ia+6));
        DISSIM3d(6,i)=mean(DISSIM6h(6,ia-6:ia+6));
        DISSIM3d(7,i)=mean(DISSIM6h(7,ia-6:ia+6));
    
end
 
%stats for 3 day mean ts
%nash sutcliffe

MSEo=0;
so2o=0;
Bo=mean(DISSIM3d(2,:))-mean(DISMASS3d(:,2));
d1o=zeros(1,length(DISSIM3d(1,:)));
d2o=zeros(1,length(DISSIM3d(1,:)));
for i=1:length(DISSIM3d(1,:))
    MSEo=(DISMASS3d(2,i)-DISSIM6h(2,i))^2+MSEo;
    so2o=(DISSIM3d(2,i)-mean(DISMASS3d(2,:)))^2+so2o;
    d1o(i)=(DISSIM3d(2,i)-DISMASS3d(2,i))^2;
    d2o(i)=((DISMASS3d(2,i)-mean(DISMASS3d(2,:)))/var(DISMASS3d(2,:)))*((DISSIM3d(2,i)-mean(DISSIM3d(2,:)))/var(DISSIM3d(2,:)));
end
%MSEo=mean(d1o);
%so2o=so2o/length(DISSIM3d(1,:));
Eo=1-MSEo/so2o;
ISEo=sqrt(mean(d1o))/mean(DISMASS3d(2,:));
RS2o=1-(MSEo/(var(DISMASS3d(2,:))+mean(DISMASS3d(2,:))));
a=cov(DISMASS3d(2,:),DISSIM3d(2,:));
Ro=a(1,2)/(var(DISMASS3d(2,:))*var(DISSIM3d(2,:)));
Ro2=mean(d2o);

%disp(['bla' num2str(a)])


% %stats
% %nash sutcliffe
% %overall time series
% MSEo=0;
% so2o=0;
% Bo=mean(DISSIM6h(2,:))-mean(DISMASS6h(:,2));
% d1o=zeros(1,length(DISSIM6h(1,:)));
% for i=1:length(DISSIM6h(1,:))
%     %MSEo=(DISMASS6h(2,i)-DISSIM6h(2,i))^2+MSEo;
%     so2o=(DISSIM6h(2,i)-mean(DISMASS6h(2,:)))^2+so2o;
%     d1o(i)=(DISSIM6h(2,i)-DISMASS6h(2,i))^2;
% end
% MSEo=mean(d1o);
% Eo=1-MSEo/var(DISMASS6h(2,:));
% ISEo=sqrt(mean(d1o))/mean(DISMASS6h(2,:));
% RS2o=1-(MSEo/(var(DISMASS6h(2,:))+mean(DISMASS6h(2,:))));
% a=cov(DISMASS6h(2,:),DISSIM6h(2,:));
% Ro=a(1,2)/(var(DISMASS6h(2,:))*var(DISSIM6h(2,:)));

%moving window 5 days
MSEw=0;
so2w=0;
B1w=zeros(1,length(DISSIM6h(1,:)));
for i=3:length(DISSIM6h(1,:))-2
    MSEw=(DISMASS6h(2,i)-DISSIM6h(2,i))^2+MSEw;
    so2w=(DISSIM6h(2,i)-mean(DISMASS6h(2,i-2:i+2)))^2+so2w;
    B1w(i)=mean(DISMASS6h(2,i-2:i+2))-mean(DISSIM6h(2,i-2:i+2));
end
Ew=1-MSEw/so2w;
Bw=mean(B1w);

%only inside rainy season (rain within last 7 days)
MSEr=0;
so2r=0;
j=1;
for i=7:length(DISSIM6h(1,:))-3
    if sum(DISSIM6h(5,i-6:i))>0
    MSEr=(DISMASS6h(2,i)-DISSIM6h(2,i))^2+MSEr;
    so2r=(DISSIM6h(2,i)-mean(DISMASS6h(2,i-2:i+2)))^2+so2r;
    B1r(j)=mean(DISMASS6h(2,i-2:i+2))-mean(DISSIM6h(2,i-2:i+2));
    j=j+1;
    end
end
Er=1-MSEr/so2r;
Br=mean(B1r);

%only inside rainy season (rain within last 7 days) and w/out wet year
MSEd=0;
so2d=0;
j=1;
for i=7:length(DISSIM6h(1,:))-3
    if sum(DISSIM6h(5,i-6:i))>0 && (i<2800 || i>3500)
    MSEd=(DISMASS6h(2,i)-DISSIM6h(2,i))^2+MSEd;
    so2d=(DISSIM6h(2,i)-mean(DISMASS6h(2,i-2:i+2)))^2+so2d;
    B1d(j)=mean(DISMASS6h(2,i-2:i+2))-mean(DISSIM6h(2,i-2:i+2));
    j=j+1;
    end
end
Ed=1-MSEd/so2d;
Bd=mean(B1d);

disp(['Nash-Sutcliffe - overall time series:             ' num2str(Eo)])
disp(['Nash-Sutcliffe - moving window of 5 days:         ' num2str(Ew)])
disp(['Nash-Sutcliffe - rainy seasons only:              ' num2str(Er)])
disp(['Nash-Sutcliffe - rainy seasons in dry years only: ' num2str(Ed)])

%graphs
figure(1)
subplot(2,1,1)
plot(checker(3,:),'Color','blue','LineWidth',1)
hold on
plot(checker(1,:),'Color','red','LineWidth',1)
plot(checker(2,:),'Color','black','LineWidth',1)

subplot(2,1,2)
plot(checker1(3,:),'Color','blue','LineWidth',1)
hold on
plot(checker1(1,:),'Color','red','LineWidth',1)
plot(checker1(2,:),'Color','black','LineWidth',1)

%print -depsc 'compare_6h_24h.ps'
figure(2)
hold off
subplot(3,1,1)
plot(DISMASS6h(2,:))
hold on
plot(DISSIM6h(2,:),'Color','red')
plot(DISSIM6h(5,:))
subplot(3,1,2)
plot(DISMASS6h(3,:))
hold on
plot(DISSIM6h(3,:),'Color','red')
subplot(3,1,3)
plot(DISMASS6h(4,:))
hold on
plot(DISSIM6h(4,:),'Color','red')
plot(DISSIM6h(7,:),'Color','green')